> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Submit a custom object bulk job

POST https://rest.test.zuora.com/objects/jobs
Content-Type: application/json

Submits a bulk job request for a bulk operation on the specified custom object records. A succcessful call returns a newly created bulk job. The job ID can be used to poll the job status or upload the CSV file if it is a `create` or `update` job.

### Limits
This custom object bulk jobs have the following limits:
* The concurrent bulk job limit per tenant is 5. Bulk jobs in `accepted`, `pending`, or `in_progress` status are counted towards the concurrent bulk job limit.
* The bulk job execuation order is not guaranteed, which means the bulk job that you submit ealier may be executed later.  
* Only the users that have the "Delete Custom Objects" permission can create a `delete` bulk job. Only the users that have the "Edit Custom Objects" permission can create a `create` or `update` bulk job. See [Platform Permissions](https://knowledgecenter.zuora.com/Billing/Tenant_Management/A_Administrator_Settings/User_Roles/h_Platform_Roles#Platform_Permissions) for more information.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/custom-objects/custom-object-jobs/post-custom-object-bulk-job

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (date, optional) — API version that determines the response schema. The default version is used if this parameter is not included. Specify `Zuora-Version` in the request header if you expect a specific response schema.

### Body (application/json)

This endpoint expects a CustomObjectBulkJobRequest.

- `namespace` (enum, required) — The namespace of the object. Custom objects belong to the `default` namespace. Zuora standard objects belong to the `com_zuora` namespace. Bulk job operations on the following Zuora standard objects are supported: * SavedQuery
  - Allowed values: `default`, `com_zuora`
- `object` (string, required) — The object that the bulk operation performs on.
- `operation` (enum, required) — The operation that the bulk job performs. Only the users that have the "Delete Custom Objects" permission can submit a `delete` bulk job request. Only the users that have the "Edit Custom Objects" permission can submit a `create` or `update` bulk job request. See [Platform Permissions](https://knowledgecenter.zuora.com/Billing/Tenant_Management/A_Administrator_Settings/User_Roles/h_Platform_Roles#Platform_Permissions) for more information.
  - Allowed values: `delete`, `create`, `update`
- `filter` (CustomObjectBulkDeleteFilter, optional) — Filters to determine which records to be deleted in the bulk delete operation.

## Response

### 200

OK

- `CreatedById` (string, optional) — The ID of the user who creates the job.
- `CreatedDate` (datetime, optional) — The time when the bulk job is created.
- `Id` (string, optional) — The custom object bulk job ID.
- `UpdatedById` (string, optional) — The ID of the user who updates the job.
- `UpdatedDate` (datetime, optional) — The time when the bulk job is updated.
- `error` (CustomObjectBulkJobResponseError, optional)
- `namespace` (enum, optional) — The namespace of the object. Custom objects belong to the `default` namespace. Zuora standard objects belong to the `com_zuora` namespace. Bulk job operations on the following Zuora standard objects are supported: * SavedQuery
  - Allowed values: `default`, `com_zuora`
- `object` (string, optional) — The object to that the bulk operation performs on.
- `operation` (enum, optional) — The operation that the bulk job performs. Only the users that have the "Delete Custom Objects" permission can submit a `delete` bulk job request. Only the users that have the "Edit Custom Objects" permission can submit a `create` or `update` bulk job request. See [Platform Permissions](https://knowledgecenter.zuora.com/Billing/Tenant_Management/A_Administrator_Settings/User_Roles/h_Platform_Roles#Platform_Permissions) for more information.
  - Allowed values: `delete`, `create`, `update`
- `processingTime` (integer, optional) — The amount of time elapsed, in milliseconds, from the submission to the completion of the bulk job.
- `recordsProcessed` (integer, optional) — The number of object records processed by the bulk job.
- `status` (enum, optional) — The status of the bulk job: - `accepted` - The job has been accepted and is ready to process. - `pending` - The job is waiting for your input. You can use [Upload a file for a custom object bulk job](https://developer.zuora.com/api-references/api/operation/POST_UploadFileForCustomObjectBulkJob) to upload a file so that the job can start creating records. - `in_progress` - The job is processing. - `completed` - The job has completed. - `failed` - The job was unable to complete. You can use [List all errors for a custom object bulk job](https://developer.zuora.com/api-references/api/operation/GET_CustomObjectBulkJobErrors) to list the errors. - `cancelled` - The job was cancelled by the server.
  - Allowed values: `accepted`, `pending`, `in_progress`, `completed`, `failed`, `cancelled`

## Errors

### 400 Bad Request Error

Invalid input

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

### 403 Forbidden Error

Unauthorized

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### CustomObjectBulkDeleteFilter

Filters to determine which records to be deleted in the bulk delete operation.

- `conditions` (list of CustomObjectBulkDeleteFilterCondition, required) — Group of field filter conditions that are evaluated in conjunction with each other using the AND operator. The minimum number of conditions is 1 and the maximum is 2.

### CustomObjectBulkJobResponseError

- `code` (integer, optional) — The error code.
- `message` (string, optional) — The error message.

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CustomObjectBulkDeleteFilterCondition

Condition evaluated on a single object field

- `field` (string, required) — The object field that is evaluated. Only filterable fields can be evaluated in the filter.
- `operator` (enum, required)
  - Allowed values: `EQ`, `GT`, `LT`, `GE`, `LE`
- `value` (any, required) — The value that the filterable `field` is evaluated against in the filter. The data type of `value` is consistent with that of the `field`.

## Examples

**Request**

```json
{
  "namespace": "default",
  "object": "passenger",
  "operation": "delete",
  "filter": {
    "conditions": [
      {
        "field": "CreatedDate",
        "operator": "LT",
        "value": null
      }
    ]
  }
}
```

**Response**

```json
{
  "CreatedById": "7b39d73f-22e6-404a-b8e7-894f7620e91c",
  "CreatedDate": "2021-03-15T06:47:18Z",
  "Id": "ed4b9701-bafb-4976-8019-b08269430153",
  "UpdatedById": "7b39d73f-22e6-404a-b8e7-894f7620e91c",
  "UpdatedDate": "2021-03-15T06:47:18Z",
  "error": {
    "code": 71012560,
    "message": "Service limit reached, please retry later."
  },
  "namespace": "default",
  "object": "passenger",
  "operation": "delete",
  "processingTime": 1882,
  "recordsProcessed": 500,
  "status": "failed"
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/objects/jobs"

payload = {
    "namespace": "default",
    "object": "passenger",
    "operation": "delete",
    "filter": { "conditions": [
            {
                "field": "CreatedDate",
                "operator": "LT",
                "value": None
            }
        ] }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/objects/jobs';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"namespace":"default","object":"passenger","operation":"delete","filter":{"conditions":[{"field":"CreatedDate","operator":"LT","value":null}]}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/objects/jobs"

	payload := strings.NewReader("{\n  \"namespace\": \"default\",\n  \"object\": \"passenger\",\n  \"operation\": \"delete\",\n  \"filter\": {\n    \"conditions\": [\n      {\n        \"field\": \"CreatedDate\",\n        \"operator\": \"LT\",\n        \"value\": null\n      }\n    ]\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/objects/jobs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"namespace\": \"default\",\n  \"object\": \"passenger\",\n  \"operation\": \"delete\",\n  \"filter\": {\n    \"conditions\": [\n      {\n        \"field\": \"CreatedDate\",\n        \"operator\": \"LT\",\n        \"value\": null\n      }\n    ]\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/objects/jobs")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"namespace\": \"default\",\n  \"object\": \"passenger\",\n  \"operation\": \"delete\",\n  \"filter\": {\n    \"conditions\": [\n      {\n        \"field\": \"CreatedDate\",\n        \"operator\": \"LT\",\n        \"value\": null\n      }\n    ]\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/objects/jobs', [
  'body' => '{
  "namespace": "default",
  "object": "passenger",
  "operation": "delete",
  "filter": {
    "conditions": [
      {
        "field": "CreatedDate",
        "operator": "LT",
        "value": null
      }
    ]
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/objects/jobs");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"namespace\": \"default\",\n  \"object\": \"passenger\",\n  \"operation\": \"delete\",\n  \"filter\": {\n    \"conditions\": [\n      {\n        \"field\": \"CreatedDate\",\n        \"operator\": \"LT\",\n        \"value\": null\n      }\n    ]\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "namespace": "default",
  "object": "passenger",
  "operation": "delete",
  "filter": ["conditions": [
      [
        "field": "CreatedDate",
        "operator": "LT",
        "value": 
      ]
    ]]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/objects/jobs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```